<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInvoiceCustomerContact ArrayType
 * @subpackage Arrays
 */
class ArrayOfInvoiceCustomerContact extends AbstractStructArrayBase
{
    /**
     * The InvoiceCustomerContact
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InvoiceCustomerContact[]
     */
    public $InvoiceCustomerContact;
    /**
     * Constructor method for ArrayOfInvoiceCustomerContact
     * @uses ArrayOfInvoiceCustomerContact::setInvoiceCustomerContact()
     * @param \StructType\InvoiceCustomerContact[] $invoiceCustomerContact
     */
    public function __construct(array $invoiceCustomerContact = array())
    {
        $this
            ->setInvoiceCustomerContact($invoiceCustomerContact);
    }
    /**
     * Get InvoiceCustomerContact value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InvoiceCustomerContact[]|null
     */
    public function getInvoiceCustomerContact()
    {
        return isset($this->InvoiceCustomerContact) ? $this->InvoiceCustomerContact : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInvoiceCustomerContact method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInvoiceCustomerContact method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInvoiceCustomerContactForArrayConstraintsFromSetInvoiceCustomerContact(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInvoiceCustomerContactInvoiceCustomerContactItem) {
            // validation for constraint: itemType
            if (!$arrayOfInvoiceCustomerContactInvoiceCustomerContactItem instanceof \StructType\InvoiceCustomerContact) {
                $invalidValues[] = is_object($arrayOfInvoiceCustomerContactInvoiceCustomerContactItem) ? get_class($arrayOfInvoiceCustomerContactInvoiceCustomerContactItem) : sprintf('%s(%s)', gettype($arrayOfInvoiceCustomerContactInvoiceCustomerContactItem), var_export($arrayOfInvoiceCustomerContactInvoiceCustomerContactItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InvoiceCustomerContact property can only contain items of type \StructType\InvoiceCustomerContact, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InvoiceCustomerContact value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceCustomerContact[] $invoiceCustomerContact
     * @return \ArrayType\ArrayOfInvoiceCustomerContact
     */
    public function setInvoiceCustomerContact(array $invoiceCustomerContact = array())
    {
        // validation for constraint: array
        if ('' !== ($invoiceCustomerContactArrayErrorMessage = self::validateInvoiceCustomerContactForArrayConstraintsFromSetInvoiceCustomerContact($invoiceCustomerContact))) {
            throw new \InvalidArgumentException($invoiceCustomerContactArrayErrorMessage, __LINE__);
        }
        if (is_null($invoiceCustomerContact) || (is_array($invoiceCustomerContact) && empty($invoiceCustomerContact))) {
            unset($this->InvoiceCustomerContact);
        } else {
            $this->InvoiceCustomerContact = $invoiceCustomerContact;
        }
        return $this;
    }
    /**
     * Add item to InvoiceCustomerContact value
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceCustomerContact $item
     * @return \ArrayType\ArrayOfInvoiceCustomerContact
     */
    public function addToInvoiceCustomerContact(\StructType\InvoiceCustomerContact $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InvoiceCustomerContact) {
            throw new \InvalidArgumentException(sprintf('The InvoiceCustomerContact property can only contain items of type \StructType\InvoiceCustomerContact, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InvoiceCustomerContact[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InvoiceCustomerContact|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InvoiceCustomerContact|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InvoiceCustomerContact|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InvoiceCustomerContact|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InvoiceCustomerContact|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InvoiceCustomerContact
     */
    public function getAttributeName()
    {
        return 'InvoiceCustomerContact';
    }
}
