<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInvoiceKeyValuePair ArrayType
 * @subpackage Arrays
 */
class ArrayOfInvoiceKeyValuePair extends AbstractStructArrayBase
{
    /**
     * The InvoiceKeyValuePair
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InvoiceKeyValuePair[]
     */
    public $InvoiceKeyValuePair;
    /**
     * Constructor method for ArrayOfInvoiceKeyValuePair
     * @uses ArrayOfInvoiceKeyValuePair::setInvoiceKeyValuePair()
     * @param \StructType\InvoiceKeyValuePair[] $invoiceKeyValuePair
     */
    public function __construct(array $invoiceKeyValuePair = array())
    {
        $this
            ->setInvoiceKeyValuePair($invoiceKeyValuePair);
    }
    /**
     * Get InvoiceKeyValuePair value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InvoiceKeyValuePair[]|null
     */
    public function getInvoiceKeyValuePair()
    {
        return isset($this->InvoiceKeyValuePair) ? $this->InvoiceKeyValuePair : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInvoiceKeyValuePair method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInvoiceKeyValuePair method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInvoiceKeyValuePairForArrayConstraintsFromSetInvoiceKeyValuePair(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInvoiceKeyValuePairInvoiceKeyValuePairItem) {
            // validation for constraint: itemType
            if (!$arrayOfInvoiceKeyValuePairInvoiceKeyValuePairItem instanceof \StructType\InvoiceKeyValuePair) {
                $invalidValues[] = is_object($arrayOfInvoiceKeyValuePairInvoiceKeyValuePairItem) ? get_class($arrayOfInvoiceKeyValuePairInvoiceKeyValuePairItem) : sprintf('%s(%s)', gettype($arrayOfInvoiceKeyValuePairInvoiceKeyValuePairItem), var_export($arrayOfInvoiceKeyValuePairInvoiceKeyValuePairItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InvoiceKeyValuePair property can only contain items of type \StructType\InvoiceKeyValuePair, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InvoiceKeyValuePair value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceKeyValuePair[] $invoiceKeyValuePair
     * @return \ArrayType\ArrayOfInvoiceKeyValuePair
     */
    public function setInvoiceKeyValuePair(array $invoiceKeyValuePair = array())
    {
        // validation for constraint: array
        if ('' !== ($invoiceKeyValuePairArrayErrorMessage = self::validateInvoiceKeyValuePairForArrayConstraintsFromSetInvoiceKeyValuePair($invoiceKeyValuePair))) {
            throw new \InvalidArgumentException($invoiceKeyValuePairArrayErrorMessage, __LINE__);
        }
        if (is_null($invoiceKeyValuePair) || (is_array($invoiceKeyValuePair) && empty($invoiceKeyValuePair))) {
            unset($this->InvoiceKeyValuePair);
        } else {
            $this->InvoiceKeyValuePair = $invoiceKeyValuePair;
        }
        return $this;
    }
    /**
     * Add item to InvoiceKeyValuePair value
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceKeyValuePair $item
     * @return \ArrayType\ArrayOfInvoiceKeyValuePair
     */
    public function addToInvoiceKeyValuePair(\StructType\InvoiceKeyValuePair $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InvoiceKeyValuePair) {
            throw new \InvalidArgumentException(sprintf('The InvoiceKeyValuePair property can only contain items of type \StructType\InvoiceKeyValuePair, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InvoiceKeyValuePair[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InvoiceKeyValuePair|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InvoiceKeyValuePair|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InvoiceKeyValuePair|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InvoiceKeyValuePair|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InvoiceKeyValuePair|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InvoiceKeyValuePair
     */
    public function getAttributeName()
    {
        return 'InvoiceKeyValuePair';
    }
}
