<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'AddPayment' => '\\StructType\\AddPayment',
            'AddPaymentResponse' => '\\StructType\\AddPaymentResponse',
            'AddPaymentXml' => '\\StructType\\AddPaymentXml',
            'AddPaymentXmlResponse' => '\\StructType\\AddPaymentXmlResponse',
            'GetAccountSetting' => '\\StructType\\GetAccountSetting',
            'GetAccountSettingResponse' => '\\StructType\\GetAccountSettingResponse',
            'SetEmptyAccountSetting' => '\\StructType\\SetEmptyAccountSetting',
            'SetEmptyAccountSettingResponse' => '\\StructType\\SetEmptyAccountSettingResponse',
            'GetAuthToken' => '\\StructType\\GetAuthToken',
            'GetAuthTokenResponse' => '\\StructType\\GetAuthTokenResponse',
            'GetCustomer' => '\\StructType\\GetCustomer',
            'GetCustomerResponse' => '\\StructType\\GetCustomerResponse',
            'GetCustomerGroup' => '\\StructType\\GetCustomerGroup',
            'GetCustomerGroupResponse' => '\\StructType\\GetCustomerGroupResponse',
            'GetCustomerGroupXml' => '\\StructType\\GetCustomerGroupXml',
            'GetCustomerGroupXmlResponse' => '\\StructType\\GetCustomerGroupXmlResponse',
            'GetCustomerTransactionData' => '\\StructType\\GetCustomerTransactionData',
            'GetCustomerTransactionDataResponse' => '\\StructType\\GetCustomerTransactionDataResponse',
            'GetCustomerV2' => '\\StructType\\GetCustomerV2',
            'GetCustomerV2Response' => '\\StructType\\GetCustomerV2Response',
            'GetCustomerV2Xml' => '\\StructType\\GetCustomerV2Xml',
            'GetCustomerV2XmlResponse' => '\\StructType\\GetCustomerV2XmlResponse',
            'GetCustomerV3' => '\\StructType\\GetCustomerV3',
            'GetCustomerV3Response' => '\\StructType\\GetCustomerV3Response',
            'GetCustomerV3Xml' => '\\StructType\\GetCustomerV3Xml',
            'GetCustomerV3XmlResponse' => '\\StructType\\GetCustomerV3XmlResponse',
            'GetCustomerV4' => '\\StructType\\GetCustomerV4',
            'GetCustomerV4Response' => '\\StructType\\GetCustomerV4Response',
            'GetCustomerV4Xml' => '\\StructType\\GetCustomerV4Xml',
            'GetCustomerV4XmlResponse' => '\\StructType\\GetCustomerV4XmlResponse',
            'GetCustomerV5' => '\\StructType\\GetCustomerV5',
            'GetCustomerV5Response' => '\\StructType\\GetCustomerV5Response',
            'GetCustomerV5Xml' => '\\StructType\\GetCustomerV5Xml',
            'GetCustomerV5XmlResponse' => '\\StructType\\GetCustomerV5XmlResponse',
            'GetCustomerXml' => '\\StructType\\GetCustomerXml',
            'GetCustomerXmlResponse' => '\\StructType\\GetCustomerXmlResponse',
            'GetInvoice' => '\\StructType\\GetInvoice',
            'GetInvoiceResponse' => '\\StructType\\GetInvoiceResponse',
            'GetInvoiceCustomerContact' => '\\StructType\\GetInvoiceCustomerContact',
            'GetInvoiceCustomerContactResponse' => '\\StructType\\GetInvoiceCustomerContactResponse',
            'GetInvoiceCustomerContactXml' => '\\StructType\\GetInvoiceCustomerContactXml',
            'GetInvoiceCustomerContactXmlResponse' => '\\StructType\\GetInvoiceCustomerContactXmlResponse',
            'GetInvoiceTransactionData' => '\\StructType\\GetInvoiceTransactionData',
            'GetInvoiceTransactionDataResponse' => '\\StructType\\GetInvoiceTransactionDataResponse',
            'GetInvoiceV2' => '\\StructType\\GetInvoiceV2',
            'GetInvoiceV2Response' => '\\StructType\\GetInvoiceV2Response',
            'GetInvoiceV2Xml' => '\\StructType\\GetInvoiceV2Xml',
            'GetInvoiceV2XmlResponse' => '\\StructType\\GetInvoiceV2XmlResponse',
            'GetInvoiceV3' => '\\StructType\\GetInvoiceV3',
            'GetInvoiceV3Response' => '\\StructType\\GetInvoiceV3Response',
            'GetInvoiceV3Xml' => '\\StructType\\GetInvoiceV3Xml',
            'GetInvoiceV3XmlResponse' => '\\StructType\\GetInvoiceV3XmlResponse',
            'GetInvoiceV4' => '\\StructType\\GetInvoiceV4',
            'GetInvoiceV4Response' => '\\StructType\\GetInvoiceV4Response',
            'GetInvoiceV4Xml' => '\\StructType\\GetInvoiceV4Xml',
            'GetInvoiceV4XmlResponse' => '\\StructType\\GetInvoiceV4XmlResponse',
            'GetInvoiceV5' => '\\StructType\\GetInvoiceV5',
            'GetInvoiceV5Response' => '\\StructType\\GetInvoiceV5Response',
            'GetInvoiceV5Xml' => '\\StructType\\GetInvoiceV5Xml',
            'GetInvoiceV5XmlResponse' => '\\StructType\\GetInvoiceV5XmlResponse',
            'GetInvoiceV6' => '\\StructType\\GetInvoiceV6',
            'GetInvoiceV6Response' => '\\StructType\\GetInvoiceV6Response',
            'GetInvoiceV6Xml' => '\\StructType\\GetInvoiceV6Xml',
            'GetInvoiceV6XmlResponse' => '\\StructType\\GetInvoiceV6XmlResponse',
            'GetInvoiceV7' => '\\StructType\\GetInvoiceV7',
            'GetInvoiceV7Response' => '\\StructType\\GetInvoiceV7Response',
            'GetInvoiceXml' => '\\StructType\\GetInvoiceXml',
            'GetInvoiceXmlResponse' => '\\StructType\\GetInvoiceXmlResponse',
            'GetUnpaidInvoice' => '\\StructType\\GetUnpaidInvoice',
            'GetUnpaidInvoiceResponse' => '\\StructType\\GetUnpaidInvoiceResponse',
            'InvalidateInvoice' => '\\StructType\\InvalidateInvoice',
            'InvalidateInvoiceResponse' => '\\StructType\\InvalidateInvoiceResponse',
            'SetBalance' => '\\StructType\\SetBalance',
            'SetBalanceResponse' => '\\StructType\\SetBalanceResponse',
            'SetBalanceXml' => '\\StructType\\SetBalanceXml',
            'SetBalanceXmlResponse' => '\\StructType\\SetBalanceXmlResponse',
            'SetCustomer' => '\\StructType\\SetCustomer',
            'SetCustomerResponse' => '\\StructType\\SetCustomerResponse',
            'SetCustomerV2' => '\\StructType\\SetCustomerV2',
            'SetCustomerV2Response' => '\\StructType\\SetCustomerV2Response',
            'SetCustomerV3' => '\\StructType\\SetCustomerV3',
            'SetCustomerV3Response' => '\\StructType\\SetCustomerV3Response',
            'SetCustomerV4' => '\\StructType\\SetCustomerV4',
            'SetCustomerV4Response' => '\\StructType\\SetCustomerV4Response',
            'SetCustomerV5' => '\\StructType\\SetCustomerV5',
            'SetCustomerV5Response' => '\\StructType\\SetCustomerV5Response',
            'SetCustomerXml' => '\\StructType\\SetCustomerXml',
            'SetCustomerXmlResponse' => '\\StructType\\SetCustomerXmlResponse',
            'SetExported' => '\\StructType\\SetExported',
            'SetExportedResponse' => '\\StructType\\SetExportedResponse',
            'SetInvoiceNumber' => '\\StructType\\SetInvoiceNumber',
            'SetInvoiceNumberResponse' => '\\StructType\\SetInvoiceNumberResponse',
            'ValidateAuthToken' => '\\StructType\\ValidateAuthToken',
            'ValidateAuthTokenResponse' => '\\StructType\\ValidateAuthTokenResponse',
            'ArrayOfPayment' => '\\ArrayType\\ArrayOfPayment',
            'ArrayOfCustomer' => '\\ArrayType\\ArrayOfCustomer',
            'ArrayOfCustomerGroup' => '\\ArrayType\\ArrayOfCustomerGroup',
            'ArrayOfInt' => '\\ArrayType\\ArrayOfInt',
            'ArrayOfCustomerV2' => '\\ArrayType\\ArrayOfCustomerV2',
            'ArrayOfCustomerV3' => '\\ArrayType\\ArrayOfCustomerV3',
            'ArrayOfCustomerV4' => '\\ArrayType\\ArrayOfCustomerV4',
            'ArrayOfCustomerV5' => '\\ArrayType\\ArrayOfCustomerV5',
            'ArrayOfInvoice' => '\\ArrayType\\ArrayOfInvoice',
            'ArrayOfInvoiceCustomerContact' => '\\ArrayType\\ArrayOfInvoiceCustomerContact',
            'InvoiceTransactionDataList' => '\\StructType\\InvoiceTransactionDataList',
            'ArrayOfInvoiceV2' => '\\ArrayType\\ArrayOfInvoiceV2',
            'ArrayOfInvoiceV3' => '\\ArrayType\\ArrayOfInvoiceV3',
            'ArrayOfInvoiceV4' => '\\ArrayType\\ArrayOfInvoiceV4',
            'ArrayOfInvoiceV5' => '\\ArrayType\\ArrayOfInvoiceV5',
            'ArrayOfInvoiceV6' => '\\ArrayType\\ArrayOfInvoiceV6',
            'ArrayOfInvoiceV7' => '\\ArrayType\\ArrayOfInvoiceV7',
            'ArrayOfInvoicePayment' => '\\ArrayType\\ArrayOfInvoicePayment',
            'Payment' => '\\StructType\\Payment',
            'Customer' => '\\StructType\\Customer',
            'CustomerGroup' => '\\StructType\\CustomerGroup',
            'CustomerV2' => '\\StructType\\CustomerV2',
            'CustomerV3' => '\\StructType\\CustomerV3',
            'CustomerV4' => '\\StructType\\CustomerV4',
            'CustomerV5' => '\\StructType\\CustomerV5',
            'Invoice' => '\\StructType\\Invoice',
            'InvoiceCustomerContact' => '\\StructType\\InvoiceCustomerContact',
            'ArrayOfInvoiceTransactionData' => '\\ArrayType\\ArrayOfInvoiceTransactionData',
            'InvoiceV2' => '\\StructType\\InvoiceV2',
            'InvoiceV3' => '\\StructType\\InvoiceV3',
            'InvoiceV4' => '\\StructType\\InvoiceV4',
            'InvoiceV5' => '\\StructType\\InvoiceV5',
            'InvoiceV6' => '\\StructType\\InvoiceV6',
            'InvoiceV7' => '\\StructType\\InvoiceV7',
            'InvoicePayment' => '\\StructType\\InvoicePayment',
            'Attribute' => '\\StructType\\Attribute',
            'InvoiceRow' => '\\StructType\\InvoiceRow',
            'InvoiceTransactionData' => '\\StructType\\InvoiceTransactionData',
            'ArrayOfInvoiceKeyValuePair' => '\\ArrayType\\ArrayOfInvoiceKeyValuePair',
            'InvoiceRowV2' => '\\StructType\\InvoiceRowV2',
            'InvoiceRowV3' => '\\StructType\\InvoiceRowV3',
            'AttributeAlternative' => '\\StructType\\AttributeAlternative',
            'InvoiceKeyValuePair' => '\\StructType\\InvoiceKeyValuePair',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
        );
    }
}
