<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCustomerV3Xml StructType
 * @subpackage Structs
 */
class GetCustomerV3Xml extends AbstractStructBase
{
    /**
     * The includeAttributes
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $includeAttributes;
    /**
     * The authToken
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $authToken;
    /**
     * The sort
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $sort;
    /**
     * The filter
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $filter;
    /**
     * Constructor method for GetCustomerV3Xml
     * @uses GetCustomerV3Xml::setIncludeAttributes()
     * @uses GetCustomerV3Xml::setAuthToken()
     * @uses GetCustomerV3Xml::setSort()
     * @uses GetCustomerV3Xml::setFilter()
     * @param bool $includeAttributes
     * @param string $authToken
     * @param string $sort
     * @param string $filter
     */
    public function __construct($includeAttributes = null, $authToken = null, $sort = null, $filter = null)
    {
        $this
            ->setIncludeAttributes($includeAttributes)
            ->setAuthToken($authToken)
            ->setSort($sort)
            ->setFilter($filter);
    }
    /**
     * Get includeAttributes value
     * @return bool
     */
    public function getIncludeAttributes()
    {
        return $this->includeAttributes;
    }
    /**
     * Set includeAttributes value
     * @param bool $includeAttributes
     * @return \StructType\GetCustomerV3Xml
     */
    public function setIncludeAttributes($includeAttributes = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeAttributes) && !is_bool($includeAttributes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeAttributes, true), gettype($includeAttributes)), __LINE__);
        }
        $this->includeAttributes = $includeAttributes;
        return $this;
    }
    /**
     * Get authToken value
     * @return string|null
     */
    public function getAuthToken()
    {
        return $this->authToken;
    }
    /**
     * Set authToken value
     * @param string $authToken
     * @return \StructType\GetCustomerV3Xml
     */
    public function setAuthToken($authToken = null)
    {
        // validation for constraint: string
        if (!is_null($authToken) && !is_string($authToken)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($authToken, true), gettype($authToken)), __LINE__);
        }
        $this->authToken = $authToken;
        return $this;
    }
    /**
     * Get sort value
     * @return string|null
     */
    public function getSort()
    {
        return $this->sort;
    }
    /**
     * Set sort value
     * @param string $sort
     * @return \StructType\GetCustomerV3Xml
     */
    public function setSort($sort = null)
    {
        // validation for constraint: string
        if (!is_null($sort) && !is_string($sort)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sort, true), gettype($sort)), __LINE__);
        }
        $this->sort = $sort;
        return $this;
    }
    /**
     * Get filter value
     * @return string|null
     */
    public function getFilter()
    {
        return $this->filter;
    }
    /**
     * Set filter value
     * @param string $filter
     * @return \StructType\GetCustomerV3Xml
     */
    public function setFilter($filter = null)
    {
        // validation for constraint: string
        if (!is_null($filter) && !is_string($filter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($filter, true), gettype($filter)), __LINE__);
        }
        $this->filter = $filter;
        return $this;
    }
}
